/// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public virtual Result Execute(ExternalCommandData commandData
                                      , ref string message, ElementSet elements)
        {
            //Get the document from external command data.
            UIDocument activeDoc = commandData.Application.ActiveUIDocument;

            Autodesk.Revit.DB.Document doc = activeDoc.Document;

            if (null == doc)
            {
                return(Result.Failed);
            }

            try
            {
                // Start detailed steel modeling transaction
                using (FabricationTransaction trans = new FabricationTransaction(doc, false, "Create cope skewed"))
                {
                    // for more details, please consult http://www.autodesk.com/adv-steel-api-walkthroughs-2019-enu
                    Reference eRef = activeDoc.Selection.PickObject(ObjectType.Element, "Pick a beam");
                    Element   elem = null;
                    if (eRef != null && eRef.ElementId != ElementId.InvalidElementId)
                    {
                        elem = doc.GetElement(eRef.ElementId);
                    }

                    if (null == elem)
                    {
                        return(Result.Failed);
                    }

                    // adding fabrication data, if the element doesn't already have it.
                    SteelElementProperties cell = SteelElementProperties.GetSteelElementProperties(elem);
                    if (null == cell)
                    {
                        List <ElementId> elemsIds = new List <ElementId>();
                        elemsIds.Add(elem.Id);
                        SteelElementProperties.AddFabricationInformationForRevitElements(doc, elemsIds);
                    }

                    FilerObject filerObj = Utilities.Functions.GetFilerObject(doc, eRef);
                    if (null == filerObj)
                    {
                        return(Result.Failed);
                    }

                    if (!(filerObj is Beam))
                    {
                        return(Result.Failed);
                    }

                    // Creating a beam, using AdvanceSteel classes
                    Beam beam = filerObj as Beam;
                    // Calculating the end and the side of the beam
                    Beam.eEnd  end    = Utilities.Functions.CalculateBeamEnd(beam, new XYZ(eRef.GlobalPoint.X, eRef.GlobalPoint.Y, eRef.GlobalPoint.Z));
                    Beam.eSide side   = Utilities.Functions.CalculateBeamSide(beam, new XYZ(eRef.GlobalPoint.X, eRef.GlobalPoint.Y, eRef.GlobalPoint.Z));
                    double     length = 1000;
                    double     depth  = -50;
                    // Adding the cope feature to the beam, using AdvanceSteel's BeamNotchEx class.
                    BeamNotchEx cope = new BeamNotchEx(end, side, length, depth);
                    beam.AddFeature(cope);

                    trans.Commit();
                }
            }

            catch (Autodesk.Revit.Exceptions.OperationCanceledException)
            {
                return(Result.Cancelled);
            }
            return(Result.Succeeded);
        }
Exemplo n.º 2
0
        internal BeamCope(AdvanceSteel.Nodes.SteelDbObject element,
                          int end, int side,
                          int cnrType, double radius,
                          int rotationType,
                          List <Property> beamFeatureProperties)
        {
            lock (access_obj)
            {
                using (var ctx = new SteelServices.DocContext())
                {
                    List <Property> defaultData     = beamFeatureProperties.Where(x => x.Level == ".").ToList <Property>();
                    List <Property> postWriteDBData = beamFeatureProperties.Where(x => x.Level == "Z_PostWriteDB").ToList <Property>();

                    double length = 0;
                    double depth  = 0;

                    length = (double)defaultData.FirstOrDefault <Property>(x => x.Name == "ReferenceLength").InternalValue;
                    depth  = (double)defaultData.FirstOrDefault <Property>(x => x.Name == "ReferenceDepth").InternalValue;

                    string existingFeatureHandle = SteelServices.ElementBinder.GetHandleFromTrace();

                    string      elementHandle = element.Handle;
                    FilerObject obj           = Utils.GetObject(elementHandle);
                    BeamNotchEx beamFeat      = null;
                    if (obj != null && obj.IsKindOf(FilerObject.eObjectType.kBeam))
                    {
                        if (string.IsNullOrEmpty(existingFeatureHandle) || Utils.GetObject(existingFeatureHandle) == null)
                        {
                            beamFeat           = new BeamNotchEx((Beam.eEnd)end, (Beam.eSide)side, length, depth);
                            beamFeat.XRotation = (BeamNotchEx.eXRotation)rotationType;
                            beamFeat.SetCorner((BeamNotch.eBeamNotchCornerType)cnrType, radius);

                            AtomicElement atomic = obj as AtomicElement;

                            if (defaultData != null)
                            {
                                Utils.SetParameters(beamFeat, defaultData);
                            }

                            atomic.AddFeature(beamFeat);

                            if (postWriteDBData != null)
                            {
                                Utils.SetParameters(beamFeat, postWriteDBData);
                            }
                        }
                        else
                        {
                            beamFeat = Utils.GetObject(existingFeatureHandle) as BeamNotchEx;
                            if (beamFeat != null && beamFeat.IsKindOf(FilerObject.eObjectType.kBeamNotchEx))
                            {
                                beamFeat.End       = (Beam.eEnd)end;
                                beamFeat.Side      = (Beam.eSide)side;
                                beamFeat.XRotation = (BeamNotchEx.eXRotation)rotationType;
                                beamFeat.SetCorner((BeamNotch.eBeamNotchCornerType)cnrType, radius);

                                if (defaultData != null)
                                {
                                    Utils.SetParameters(beamFeat, defaultData);
                                }

                                if (postWriteDBData != null)
                                {
                                    Utils.SetParameters(beamFeat, postWriteDBData);
                                }
                            }
                            else
                            {
                                throw new System.Exception("Not a Beam Feature");
                            }
                        }
                    }
                    else
                    {
                        throw new System.Exception("No Input Element found");
                    }

                    Handle = beamFeat.Handle;
                    SteelServices.ElementBinder.CleanupAndSetElementForTrace(beamFeat);
                }
            }
        }